// lib to allow writing (and thus printing) to a char array
// includes read and write functions (inherits from Stream)
// this is the anonymous version of awriter that uses strlen instead of internal pointers

// includes:
// set(array, size) -uses existing array, size needed for availableForWrite(), requires + 1 for null eg char c[20] => begin(c,19)
// write(byte)
// clear() sets first to null
// availableForWrite() how many bytes free, up to size
// read()- returns -1 on nothing to return
// peek()- returns -1 on nothing to return
// available()

#ifndef cwrite_h
#define cwrite_h

#include "Arduino.h"

class cwrite: public Stream{
  public:
    cwrite();
    void set(char* a);
    virtual size_t write(uint8_t d);
    void clear();
    int peek();
    int available();
    int read();
  private:
    char* _a;
};

#endif


